SCM_CHANNELNAMES_REGEXPS = {
	["%[Guild%]"] = "g",
	["%[Party%]"] = "p",
	["%[Raid%]"] = "R",
	["%[Raid Leader%]"] = "RL",
	["%[Raid Warning%]"] = "RW",
	["%[Officer%]"] = "o",
	["%[%d+%. WorldDefense%]"] = "WD",
	["%[%d+%. General%]"] = "G",
	["%[%d+%. LocalDefense%]"] = "LD",
	["%[%d+%. Trade%]"] = "T",
	["%[%d+%. GuildRecruitment %- .*%]"] = "GR",
	["%[%d+%. LookingForGroup%]"] = "LFG",
	["%[Battleground%]"] = "B",
	["%[Battleground Leader%]"] = "BGL",
}

local customChannels = {
	["%[%d+%.%stankcamel%]"] = "|cffff2222Tank|r",
	["%[%d+%.%shealcamel%]"] = "|cff4444ffHeal|r",
	["%[%d+%.%sbmclock%]"] = "|cff9382c9Lock|r",
	["%[%d+%.%sbehindrogues%]"] = "|cfffff468Rogue|r",
	["%[%d+%.%s(%w*)%]"] = "|cff990066(|r%1|cff990066)|r",
}

local orig = nil

local function addMessage(frame, text, ...)
	if type(text) == "string" then
		for k, v in pairs(SCM_CHANNELNAMES_REGEXPS) do
			text = text:gsub(k, v)
		end
		for k, v in pairs(customChannels) do
			text = text:gsub(k, v)
		end
	end
	return orig(frame, text, ...)
end

orig = ChatFrame1.AddMessage
ChatFrame1.AddMessage = addMessage

