scmUrlCopy = {}

SCM_URL_STYLE = " |cffffffff|Hurl:%s|h[%s]|h|r "

local patterns = {
	{ " www%.([_A-Za-z0-9-]+)%.([_A-Za-z0-9-%.&/]+)%s?", "http://www.%1.%2"},
	{ " (%a+)://(%S+)%s?", "%1://%2"},
	{ " ([_A-Za-z0-9-%.]+)@([_A-Za-z0-9-]+)(%.+)([_A-Za-z0-9-%.]+)%s?", "%1@%2%3%4"},
	{ " ([_A-Za-z0-9-]+)%.([_A-Za-z0-9-]+)%.(%S+)%s?", "%1.%2.%3"},
	{ " ([_A-Za-z0-9-]+)%.([_A-Za-z0-9-]+)%.(%S+)%:([_0-9-]+)%s?", "%1.%2.%3:%4"},
	{ " ([_A-Za-z0-9-]+)%.(%a%a%a)%s?", "%1.%2"},
}
local currentLink
local _G = getfenv(0)
local origItemRef = nil

local function filter(self, event, msg, ...)
	local text = msg
	for i, v in ipairs(patterns) do
		text = text:gsub(v[1], SCM_URL_STYLE:format(v[2], v[2]))
	end
	return false, text, ...
end

local function setItemRef(link, text, button)
	if link:sub(1, 3) == "url" then
		currentLink = link:sub(5)
		StaticPopup_Show("SCMUrlCopyDialog")
		return
	end
	return origItemRef(link, text, button)
end

function scmUrlCopy:Disable()
	if origItemRef then
		_G.SetItemRef = origItemRef
	end
end

function scmUrlCopy:Enable()
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", filter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", filter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", filter)

	origItemRef = _G.SetItemRef
	_G.SetItemRef = setItemRef

	StaticPopupDialogs["SCMUrlCopyDialog"] = {
		text = "URL",
		button2 = TEXT(CLOSE),
		hasEditBox = 1,
		hasWideEditBox = 1,
		OnShow = function()
			local editBox = _G[this:GetName().."WideEditBox"]
			if editBox then
				editBox:SetText(currentLink)
				editBox:SetFocus()
				editBox:HighlightText(0)
			end
			local button = _G[this:GetName().."Button2"]
			if button then
				button:ClearAllPoints()
				button:SetWidth(200)
				button:SetPoint("CENTER", editBox, "CENTER", 0, -30)
			end
		end,
		EditBoxOnEscapePressed = function() this:GetParent():Hide() end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	}
end

scmUrlCopy:Enable()

